// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
#include "pickGame.h"
#include "dialogWnd.h"
#include "resource.h"
#include <commctrl.h>
#include <stdio.h>

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
static BOOL CALLBACK PickGameProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void DoPickGame(HWND hParent)
{
	if( CanGame() )
		DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_GAMENBR), hParent, PickGameProc, (LPARAM)(NULL));
}

// ----------------------------------------------------------------------------
static BOOL CALLBACK PickGameProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			TCHAR     maxGame[32];
			_stprintf(maxGame, _T("%d"), MAXGAME);

			SendDlgItemMessage(hDlg, IDC_EDIT, EM_SETLIMITTEXT, _tcslen(maxGame), 0);
			SendDlgItemMessage(hDlg, IDC_SPIN, UDM_SETRANGE32, 0, MAXGAME);

			return InitDlgProc(_T("GameNumberDialog"), hDlg, 65535, 65535);
		}
		break;

	case WM_COMMAND:
		{
			switch( LOWORD(wParam) )
			{
			case IDOK:
				{
					BOOL xlt;
					int  nbr = GetDlgItemInt(hDlg, IDC_EDIT, &xlt, FALSE);

					if( !nbr ) RndGame(true);
					else
					{
						gameSeed = nbr - 1;
						NewGame(true);
					}

					EndDialog(hDlg, LOWORD(wParam));
				}
				break;

			case IDCANCEL:
				{
					EndDialog(hDlg, LOWORD(wParam));
				}
				break;
			}
		}
		break;
	}

	return FALSE;
}
