// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
#include "rebar.h"
#include <commctrl.h>

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
HWND Rebar_Create(HWND hParent, UINT id)
{
	HWND   hCtl = CreateWindowEx(0, REBARCLASSNAME, NULL, CCS_NODIVIDER | RBS_BANDBORDERS | RBS_VARHEIGHT | RBS_AUTOSIZE | WS_CHILD | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_VISIBLE, 0, 0, 0, 0, hParent, (HMENU)id, GetModuleHandle(NULL), NULL);
	return hCtl;
}

// ----------------------------------------------------------------------------
void Rebar_AppendBand(HWND hCtl, HWND hChild, const SIZE& size)
{
	REBARBANDINFO rbbi = { sizeof(rbbi), RBBIM_CHILD | RBBIM_CHILDSIZE, 0, 0, 0, 0, 0, 0, hChild, size.cx, size.cy };
	SendMessage(hCtl, RB_INSERTBAND, -1, (LPARAM)&rbbi);
}

// ----------------------------------------------------------------------------
RECT Rebar_BandBorders(HWND hCtl)
{
	RECT   bb;
	SendMessage(hCtl, RB_GETBANDBORDERS, 0, (LPARAM)&bb);
	return bb;
}

// ----------------------------------------------------------------------------
COLORREF Rebar_BkColor(HWND hCtl)
{
	return SendMessage(hCtl, RB_GETBKCOLOR, 0, 0);
}
