// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
#include "showHelp.h"
#include "dialogWnd.h"
#include "resource.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
static BOOL CALLBACK ShowHelpProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void DoShowHelp(HWND hParent)
{
	DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_HELP), hParent, ShowHelpProc, (LPARAM)(NULL));
}

// ----------------------------------------------------------------------------
static BOOL CALLBACK ShowHelpProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
/*			LPCTSTR text =
_T("o 0-9 sets a cell to that number (0 clears a cell)\r\n") \
_T("o shift   1-9 will toggle a cell's possible number mark (emphasized)\r\n") \
_T("o control 1-9 will toggle a cell's possible number mark (de-emphasized)\r\n") \
_T("o + followed by a number will mimic the \"shift   + 1-9\" action\r\n") \
_T("o - followed by a number will mimic the \"control + 1-9\" action\r\n") \
_T("o for the +N and -N actions, the key sequences =N and _N are equivalent to\r\n") \
_T("  the +N and -N actions, respectively\r\n") \
_T("o left double-click will run a cell through the lowest available value\r\n") \
_T("  within its sub-grid, up to the highest available, wrapping as necessary\r\n") \
_T("o the space bar will mimic the left double-click action\r\n") \
_T("o right single-click will bring up a context menu from which you can choose\r\n") \
_T("  from various cell settings (0-9, mark as possible emphasized/de-emphasized,\r\n") \
_T("  unmark as possible, etc.)\r\n") \
_T("o left single-click followed by a delayed left single-click will mimic the\r\n") \
_T("  right single-click action (the delay must be longer than the system's\r\n") \
_T("  double-click time)\r\n") \
_T("o enter will mimic the right single-click action\r\n") \
_T("o the \"context menu\" button will mimic the right single-click action\r\n") \
_T("o left, right, up, and down arrow keys will move the cell \"cursor\" by single\r\n") \
_T("  cell increments, wrapping as necessary (up/down do not wrap, left/right will\r\n") \
_T("  wrap unless the cell cursor is within the top-left or bottom-right cell)\r\n") \
_T("o tab will move the cell cursor \"forward\" by a sub-grid, wrapping as necessary)\r\n") \
_T("  shift tab will move the cell cursor \"backward\" by a sub-grid (wrapping)\r\n") \
_T("o home will move the cell cursor to the top-left     cell\r\n") \
_T("o end  will move the cell cursor to the bottom-right cell\r\n") \
_T("\r\n") \
_T("o P   - previous game\r\n") \
_T("o N   - next     game\r\n") \
_T("o D   - random   game\r\n") \
_T("o U   - enter    game #\r\n") \
_T("o R   - restart  game\r\n") \
_T("o S   - solve    game\r\n") \
_T("o ESC - quit app\r\n") \
_T("o B   - restart  game using beginner difficulty level\r\n") \
_T("o E   - restart  game using easy     difficulty level\r\n") \
_T("o M   - restart  game using medium   difficulty level\r\n") \
_T("o H   - restart  game using hard     difficulty level\r\n") \
_T("o X   - restart  game using extreme  difficulty level\r\n") \
_T("o C   - check    game for errors\r\n") \
_T("o V   - show     game's blank cell's possible values\r\n") \
_T("o F1  - help  box\r\n") \
_T("o A   - about box\r\n");

			SetDlgItemText(hDlg, IDC_EDIT, text);*/

			return InitDlgProc(_T("HelpDialog"), hDlg, 65535, 65535);
		}
		break;

	case WM_COMMAND:
		{
			switch( LOWORD(wParam) )
			{
			case IDOK:
			case IDCANCEL:
				{
					EndDialog(hDlg, LOWORD(wParam));
				}
				break;
			}
		}
		break;
	}

	return FALSE;
}
