// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
#include "statusbar.h"
#include <commctrl.h>
#include "wnd.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
HWND Statusbar_Create(HWND hParent, UINT id)
{
	HWND   hCtl = CreateWindowEx(0, STATUSCLASSNAME, NULL, WS_CHILD | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_VISIBLE, 0, 0, 0, 0, hParent, (HMENU)id, GetModuleHandle(NULL), NULL);
	return hCtl;
}

// ----------------------------------------------------------------------------
void Statusbar_SetParts(HWND hCtl, int sizes[], int n, bool adjust)
{
	if( !n ) return;

	RECT cr = Wnd_InnerRect(GetParent(hCtl));
	int* posis = adjust ? NULL  : new int[n];
	int* parts = posis  ? posis : sizes;

	parts[n-1] = -1;

	if( n > 1 ) parts[n-2] = cr.right - sizes[n-2];

	if( n > 2 )
	{
		for( int p = n-3; p >= 0; p-- )
			parts[p] = parts[p+1] - sizes[p];
	}

	SendMessage(hCtl, SB_SETPARTS, n, (LPARAM)parts);

	if( posis ) delete [] posis;
}

// ----------------------------------------------------------------------------
void Statusbar_Update(HWND hCtl, LPCTSTR texts[], int n)
{
	for( int t = 0; t < n; t++ )
	{
		int    textl = LOWORD(SendMessage(hCtl, SB_GETTEXTLENGTH, t, 0));
		TCHAR* texto = new TCHAR[textl+2];

		SendMessage(hCtl, SB_GETTEXT, t, (LPARAM)texto);

		if( _tcscmp(texts[t], texto) )
			SendMessage(hCtl, SB_SETTEXT, t, (LPARAM)texts[t]);

		delete [] texto;
	}
}
