// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
#ifndef _sudoku_h_
#define _sudoku_h_

// ----------------------------------------------------------------------------
#define SDSIZE    3              // NxN grid size for a constrained sub-grid
#define SDSIZESQ (SDSIZE*SDSIZE) // total # of cols and # of rows in puzzle

enum GameType
{
	gameMinimum=0,
	gameBeginner,
	gameEasy,
	gameMedium,
	gameHard,
	gameExtreme
};

struct GameCell
{
	char nbr; // the correct 1-9 number
	char usr; // the user entered number (0=don't show)
	bool fix; // editable indicator
	bool sho; // display indicator
};

// ----------------------------------------------------------------------------
void NewGame();
void ClrGame();
void SetGame(int   seed, char* user, char* grid, char* give);
void SavGame(char* grid, int   type);
void BegGame();
bool ChkGame(bool stop);
void EndGame();
int  GetNextNumber(int row, int col);
void GetPossibles (int row, int col, bool* possible);
void SetDiffDefaults(int* percents=0);

// ----------------------------------------------------------------------------
extern GameCell gameCell[SDSIZESQ][SDSIZESQ]; // row, col
extern bool     gameErrs[SDSIZESQ][SDSIZESQ]; // row, col
extern GameType gameType;
extern int      gameSeed;
extern bool     gameWon;
extern int      gameRow;
extern int      gameCol;
extern int      gameDiff[gameExtreme+1];      // difficulty levels as a percentage
extern int      gameLevel;
extern int      gameSolves;
extern bool     gameGen;

#endif
